using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using FlexNA.Framework;
using FlexNA.Framework.Graphics;
using FlexNA.Framework.Application;
using FlexNA.Framework.Application.Interactive;
using FlexNA.Framework.Application.Interactive.Controls;
using Resources = FlexNA.Framework.Resources;

namespace $safeprojectname$
{
    /// <summary>
    /// This is the main type for your FlexNA application
    /// </summary>
    public class $safeprojectname$ : FlexApp
    {
        ContentManager appContent;
        Screen startup_screen;

        public $safeprojectname$()
        {
            // Initialize this application's ContentManager
            appContent = new ContentManager(Content.ServiceProvider, "Content");

            // Set display mode
            SetDisplayMode(DisplayModePresets.Windowed_800x600);

            // Game Timing option
            IsFixedTimeStep = false;

            // Other options
            IsMouseVisible = true;
            Window.Title = "My FlexNA Application";

            // Create a startup screen
            createStartupScreen();
        }

        void createStartupScreen()
        {
            // Setup a FlexNA screen
            startup_screen = new Screen(this, new Color(50, 50, 50));
            Components.Add(startup_screen);
        }

        /// <summary>
        /// Allows the application to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            #region PREREQUISITE CODE - DO NOT MODIFY

            // Initializes the base FlexNA application and any components added to the Components list
            base.Initialize();

            #endregion

            // Create any FlexWindow objects you need here.  
            // Once you've set any initial properties, call the Show() method on the FlexWindow object 
            // to make the window appear immediately, or call the Load() method to simply load its content 
            // into memory without making the window appear immediately.  You may then call Show() later.
            // Loading flex windows into the background in this manner can help make graphically intensive
            // windows or windows that contain many controls appear faster when needed.
        }

        /// <summary>
        /// LoadContent will be called once and is the place to load
        /// all of your content (textures, sounds, etc.).
        /// </summary>
        protected override void LoadContent()
        {
            #region PREREQUISITE CODE - DO NOT MODIFY

            // Other screens may have required application resources to be loaded prior to their own, if this happens then
            // the application's content will already be loaded before XNA calls the method itself.  This check ensures that
            // the application's content is only loaded once.
            if (ContentLoaded) return;

            // Allow base class to load its content
            base.LoadContent();

            #endregion

            // Load your application's content here.
            // - Use appContent.Load() to load resources from this application's Content project.
            // - Content.Load() is used to load resources from the FlexNA Framework's Content project.
            //   Note:  Content.Load() will be unavailable when using FlexNA from a compiled DLL.  Instead,
            //   use the Resources alias to access the available "built-in" content.
        }

        /// <summary>
        /// UnloadContent will be called once and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            #region PREREQUISITE CODE - DO NOT MODIFY

            // Allow base class to unload its content
            base.UnloadContent();

            #endregion
        }

        /// <summary>
        /// Allows the application to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            #region PREREQUISITE CODE - DO NOT MODIFY

            // Allow base class to update itself after this class updates
            base.Update(gameTime);

            #endregion
        }

        /// <summary>
        /// This is called when the application should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            #region PREREQUISITE CODE - DO NOT MODIFY

            // Allow the base class to draw its content first
            base.Draw(gameTime);

            #endregion

            // NOTE:  The Screen components draw all loaded and visible flex windows in their own Draw() methods.
            //        You can add your own custom drawing logic here using SpriteBatch or accessing the graphics
            //        device object directly.  Anything drawn in this method will appear over everything else.
            //        This method provides the top-most layer for drawing.
            //
            //        All game and application drawing can be handled by creating a Screen object.

            //        Add draw logic to this method for debug or diagnostic purposes, or to implement custom
            //        graphic overlay behavior.
        }
    }
}
